//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA rtlinux executive "sched_param" declarations
// This file will be included during "/usr/src/linux/include/linux/sched.h"
// to expand sched_param structure
//
// Project:	Yasa 2
// Author :	Jan Blumenthal
// Start  : 2001/11/26
// $Header: /sources/yasa/executives/rtlinux/kernel/include/yasa_rtlinux_schedparam.h,v 1.2 2003/01/22 17:02:39 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef	YASA_RTLINUX_SCHEDPARAM_INCLUDE
#define	YASA_RTLINUX_SCHEDPARAM_INCLUDE



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef __RTL__

//#include <yasa/yasa.h>		// do not include here !!!
#include <rtl_time.h>
#ifndef YASA_TIME
#define YASA_TIME					hrtime_t
#endif

struct rtl_thread_struct;

struct sched_param
{
	int						sched_priority;
	YASA_TIME				yasa_requiredtime;
	YASA_TIME				yasa_resumetime;
	YASA_TIME				yasa_deadline;
	YASA_TIME				yasa_period;

	/* behaviour in critical deadline situations */
	YASA_TIME				deadlinetolerance;			// tolerance after deadline miss
	int						yasa_dl_behaviour;
	struct rtl_thread_struct* yasa_dl_emergencythread;	// ptr to emergency task, which should be created and
														// will be pass over automatically in the SUSPENDED state
														// during the initialization of the task set
};
#define	yasa_priority		sched_priority;				// map the entries of the origin structure to yasa members


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#else
struct sched_param
{
	int						sched_priority;
};
#endif

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif													// ifndef YASA_RTLINUX_SCHEDPARAM_INCLUDE