//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA simulator function declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/01/26
// $Header: /sources/yasa/executives/simulator/sources/simulator_functions.h,v 1.3 2003/01/23 09:18:30 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASA_SIMULATORFUNCTIONS_INCLUDE
#define	YASA_SIMULATORFUNCTIONS_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// global simulator functions
int			ys_scheduling(YASA_SCHEDULER *schedulers);
int 		ys_mutex_lock(YASA_THREAD *thread, int id);
void 		ys_mutex_unlock(YASA_THREAD *thread, int id);
void 		ys_free_mutex( YASA_MUTEX **ptr );
int 		ys_alloc_mutex( YASA_MUTEX **ptr, YASA_MUTEX_ATTR *mutexattr );
void 		ys_do_signal(YASA_THREAD *thread);
YASA_MUTEX* ys_find_mutex( YASA_SCHEDULER *scheduler, int id );


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif														// ifdef YASA_SIMULATORFUNCTIONS_INCLUDE
