//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA additional logging definitions. These settings are used to enable the full logfile support
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/04/10
// $Header: /sources/yasa/include/yasa/yasa_loggingsupport.h,v 1.2 2003/01/23 09:18:31 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASA_LOGGING_SUPPORT_INCLUDE
#define	YASA_LOGGING_SUPPORT_INCLUDE

#ifdef YP_ENABLE_LOGGING


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This project should support the following logging messages
#define YASA_SUPPORT_LOG_THREAD_CREATED			// A new task was created
#define YASA_SUPPORT_LOG_THREAD_ACTIVATE		// when should the task start (make a flash)?
#define YASA_SUPPORT_LOG_THREAD_EXIT			// thread is exiting
#define YASA_SUPPORT_LOG_THREAD_START			// start of computing (make opened bracket)
#define YASA_SUPPORT_LOG_THREAD_CONT			// task is continuing, param: activation time
#define YASA_SUPPORT_LOG_THREAD_SUSPEND			// task finished (make closed bracket), param: activation time
#define YASA_SUPPORT_LOG_THREAD_TOLERANCE_START	// start of computing after deadline, param: activation time
#define YASA_SUPPORT_LOG_THREAD_TOLERANCE_CONT	// task is continuing, param: activation time
#define YASA_SUPPORT_LOG_THREAD_TOLERANCE_SUSPEND// thread suspends after deadline, param: activation time
#define YASA_SUPPORT_LOG_THREAD_SKIPPED			// time: activation time, param: deadline
#define YASA_SUPPORT_LOG_THREAD_TYPE			// thread type changed (non periodic -> periodic)
#define YASA_SUPPORT_LOG_THREAD_EXCLUDED		// thread is excluded (param=1=yes)
#define YASA_SUPPORT_LOG_DEADLINE_MATCH			// upward arrow (black), time: now, param: current deadline // param=activation time
#define YASA_SUPPORT_LOG_DEADLINE_MISS			// make upward arrow (red), time: now, param: current deadline, param=activation time
#define YASA_SUPPORT_LOG_DEADLINE_MISS_DETECTED	// param=time when deadline miss was detected
#define YASA_SUPPORT_LOG_DEADLINE_TOLERANCE_MISS// deadline tolerance was missed, param=activation time
#define YASA_SUPPORT_LOG_TIME_TO_COMPUTE		// param=time to compute at the moment the scheduler detected a deadline miss
#define YASA_SUPPORT_LOG_MUTEX_CREATED			// mutex was created
#define YASA_SUPPORT_LOG_MUTEX_DESTROYED		// mutex was destroyed
#define YASA_SUPPORT_LOG_MUTEX_LOCKED			// mutex was locked successfully
#define YASA_SUPPORT_LOG_MUTEX_TRY_N_BLOCKED	// mutex was not locked successfully and blocked
#define YASA_SUPPORT_LOG_MUTEX_UNLOCKED			// mutex was unlocked successfully
#define YASA_SUPPORT_LOG_MUTEX_RELOCKED			// mutex was relocked (usually not allowed)
#define YASA_SUPPORT_LOG_MUTEX_NOT_LOCKED 		// error during unlocking semaphore
#define YASA_SUPPORT_LOG_MUTEX_PRIORITY_CHANGED	// during mutex lock the priority of the thread is changed
#define YASA_SUPPORT_LOG_MUTEX_SYSTEM_CEILING	// system ceiling changed
#define YASA_SUPPORT_LOG_MESSAGE				// make message flag
#define YASA_SUPPORT_LOG_EMERGENCY_THREAD		// emergency thread started
#define YASA_SUPPORT_LOG_SCHEDULER_CALLED		// the scheduler was called
#define YASA_SUPPORT_LOG_SCHEDULER_FINISHED		// param=time, when should the scheduler should be called again?
#define YASA_SUPPORT_LOG_SCHEDULER_SWITCH		// param=id of old thread
#define YASA_SUPPORT_LOG_SCHEDULER_SYNCHRONIZED_START // param=
#define YASA_SUPPORT_LOG_IDLE_THREAD			// no thread selected by scheduler

#define YASA_SUPPORT_LOG_COUNT_SCHEDULER_CALLS	// count scheduler calls


#endif															// ifndef YP_ENABLE_LOGGING

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif															// ifndef YASA_LOGGING_SUPPORT_INCLUDE
