//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA project tastset thread execution part.
//
// Project:		Yasa 2
// Filename: 	$(YASA_PROJECT)/sources/threads.c
// Author:	  	Jan Blumenthal
// date:		2002/01/17
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <yasa/yasa.h>


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
pthread_mutex_t * yp_getmutex(int id);
#define ID_MUTEX1		1


//+++++++++ periodic thread +++++++++++\\

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void* yp_thread1_init( void* param, void **userdata )
{
	// set deadline
	// alloc needed resources (memory)
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void yp_thread1_cleanup( void **userdata )
{
	// cleanup memory
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This is called periodically
// Input:	None
// Output: 	return value of this thread
int yp_thread1_execute(void **userdata)
{
	int				retvalue=0;
	int				i,k;
	pthread_mutex_t	*mutex;

	rtl_printf("thread: %d is entering loop\n", tinfo->attr->id);

	mutex=yasa_getmutex(ID_MUTEX1);

	YASA_PERIODIC_START
	{
		if ( mutex )
			pthread_mutex_lock( mutex );

		for ( i=0; i<1000000; i++)
		{
			j=i*i+j;
			j+=k*i+54;
			j=j>>4;
			j=k+i+j;
		}
		k++;

		if ( mutex )
			pthread_mutex_unlock( mutex );

		if ( k==10 )
			break;
	}
	YASA_PERIODIC_END(retvalue)

	rtl_printf("Thread %d ready.", tinfo->attr->id);

}







//+++++++++ non periodic thread +++++++++++\\

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
int yp_thread1_init( YASA_THREADvoid* param )
{
	// set deadline
	// alloc needed resources (memory)
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void yp_thread1_cleanup( YASA_THREAD *thread)
{
	// cleanup memory
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int yp_thread1_execute()
{
	int		retvalue;

	YASA_NONPERIODIC_START
	{
		for ( i=1; i<2000000; i++)
		{
			k=i*i;
			k=k<2+i*3;
		}
		i=k;
	}
	YASA_NONPERIODIC_END(retvalue)
}
*/