//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA test project source code
//
// Project:		Yasa 2
// Filename: 	$(YASA_PROJECT)/testproject.c
// Author:	  	Jan Blumenthal
// date:		2002/05/02
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <yasa/yasa.h>


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
pthread_mutex_t* yp_getmutex(int id);

/*
#define ID_MUTEX1		1
#define ID_MUTEX2		2
#define ID_MUTEX3		3
*/

void compute1(void)
{
	int i,j=0;
	for ( i=0; i<50000; i++)
	{
		j=i*i+j+1;
		j+=5*i+54;
		j=j>>4;
		j=i+j;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This is called periodically
// Input:	None
// Output: 	return value of this thread
void* yp_thread1_execute(void **userdata)
{
	int				retvalue=0;
	int				k=1;
	int				a=0;
	pthread_mutex_t	*mutex1, *mutex2;

	rtl_printf("thread %s is entering loop\n", yasa_id_get_name( & (pthread_self()->id) ) );
	mutex1=yp_getmutex(MUTEXID_MUTEX_1);
	mutex2=yp_getmutex(MUTEXID_MUTEX_2);

	YASA_PERIODIC_START
	{
		if ( a<4 )
		{
			//rtl_printf("thread %d is in loop: %d\n",pthread_self()->id,a );
			a++;
		}

		compute1();
		if ( mutex1 )
			pthread_mutex_lock( mutex1 );

		compute1();

		if ( mutex2 )
			pthread_mutex_lock( mutex2 );

		compute1();
		compute1();
		if ( mutex2 )
			pthread_mutex_unlock( mutex2 );

		if ( mutex1 )
			pthread_mutex_unlock( mutex1 );
		compute1();

		k++;
		if ( k==10 )
			break;
	}
	YASA_PERIODIC_END

	return (void*)retvalue;
}



