//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA global definitions
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/16
// $Header: /sources/yasa/yasa/yasa.c,v 1.2 2003/01/23 09:18:33 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <yasa/yasa.h>


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Insert default values
int yasa_id_init(YASA_ID *id)
{
	const char	*ptr=YASA_DEFAULT_NAME;
	id->id=YASA_DEFAULT_ID;

	memcpy ( &(id->name), ptr, strlen(ptr) < YASA_MAXNAME ? strlen(ptr)+1 : YASA_MAXNAME );
	id->name[YASA_MAXNAME+1]=0;
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int yasa_id_copy(YASA_ID *dest, const YASA_ID *src)
{
	const char	*ptr=src->name;
	dest->id=src->id;
	memcpy ( &(dest->name), ptr, strlen(ptr) < YASA_MAXNAME ? strlen(ptr)+1 : YASA_MAXNAME );
	dest->name[YASA_MAXNAME]=0;
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int yasa_id_get_id(const YASA_ID *id)
{
	return id->id;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
const int* yasa_id_get_idptr(const YASA_ID *id)
{
	return &id->id;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int	yasa_id_set_id(YASA_ID *id, int newid)
{
	id->id=newid;
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
const char *yasa_id_get_name(const YASA_ID *id)
{
	return id->name;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int yasa_id_set_name(YASA_ID *id, const char *name)
{
	int a;
	for (a=0; a<YASA_MAXNAME-1; a++)
	{
		if ( ! *name )
			break;
		(id->name)[a]=*name;
		name++;
	}
	(id->name)[a]=0;
	return 0;
}
