//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA configuration declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/config.h,v 1.5 2003/01/24 15:47:40 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_CONFIG_INCLUDE
#define	YASAGUI_CONFIG_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
typedef const char *				CONFIG_STRING;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! Configuration strings
#define YPC_WORKSPACE				"workspace"
#define YPC_AUTHOR					"author"
#define YPC_VERSION					"version"
//efine YPC_YASAVERSION				"required_yasa_version"			// float value
#define YPC_CREATION_DATE			"start_of_workspace"
#define YPC_LASTCHANGED_DATE		"last_changed"
#define YPC_PROJECTS				"projects"
#define YPC_DOCTYPE					"!DOCTYPE"
#define YPC_YASA_WORKSPACE			"YASA_WORKSPACE"
#define YPC_STATE_YES				"yes"
#define YPC_STATE_NO				"no"

#define YPC_TASK					"task"
#define YPC_MUTEX					"mutex"
#define YPC_ENVIRONMENT				"environment"
#define YPC_RESULTS					"results"
#define YPC_TIMING					"timing"
#define YPC_STATISTIC				"statistic"

#define YPC_PROJECT					"project"
#define YPC_SORTED_BY_TASKS			"tasks"
#define YPC_SORTED_BY_MUTEXES		"mutex"
#define YPC_SORTED_BY_CPU			"cpu"
#define YPC_PROJECT_DIR				"projectdir"

#define YPC_DESCRIPTION				"description"
#define YPC_ID						"id"
#define YPC_NAME					"name"
#define YPC_CPU						"cpu"
#define YPC_MAX_CPU					"maxcpu"
#define YPC_NUMBER_OF_CPUS			"number_of_cpus"
//#define YPC_NUMBER_OF_TASKS			"number_of_tasks"
//#define YPC_NUMBER_OF_MUTEXES		"number_of_mutexes"
//#define YPC_NUMBER_OF_ENVIRONMENTS	"number_of_environments"
#define YPC_CALC_PREEMPTIONTIME		"calc_preemption_time"			// derivable by projects->environments->schedulers
#define YPC_SCHEDULING_TIME			"scheduling_time"
#define YPC_SYNCHRONIZATION_OFFSET	"synchronization_offset"
#define YPC_SCHEDULER				"scheduler"
#define YPC_SCHEDULERNAME			"schedulername"
#define YPC_EXECUTIVENAME			"executivename"
#define YPC_TIMER_TICK				"timer_tick"					// derivable by projects->environments->schedulers
#define YPC_END_TIME				"end_tick"
#define YPC_MIN_TIMER_TICK			"min_timer_tick"

#define YPC_TASK_TYPE				"task_type"
#define YPC_SERVER_TYPE				"server_type"
#define YPC_SERVER					"server"
#define YPC_PRIORITY				"priority"
#define YPC_PERIOD					"period"
#define YPC_REQUIRED_TIME			"required_time"
#define YPC_DEADLINE				"deadline"
#define YPC_DEADLINE_TOLERANCE		"deadline_tolerance"
#define YPC_DEADLINE_BEHAVIOUR		"deadline_behaviour"
#define YPC_RESOURCE_TIME			"resource_time"
#define YPC_RESUME_TIME				"resume_time"
#define YPC_OFFSET					"offset"
#define YPC_INIT					"function_init"
#define YPC_EXECUTE					"function_execute"
#define YPC_CLEANUP					"function_cleanup"
#define YPC_HEADER					"header"
#define YPC_SOURCE					"source"
#define YPC_PATH					"path"
#define YPC_TIME					"time"
#define YPC_ACTION					"action"
#define YPC_PROTOCOL				"protocol"			// see $YASA/include/yasa/yasa_resources.h
//#define YPC_PREEMPTCEILING			"preemptceiling"
//#define YPC_PRIORITYCEILING			"priorityceiling"
//#define YPC_DERIVED_TIMERTICK			"derived_timertick"
//#define YPC_DERIVED_CALCPREEMPTCEILING	"derived_calcpreemptceiling"


// scheduler & executive options
#define YPC_GCC_COMPILER_OPTIONS	"gcc_compiler_options"
#define YPC_LOGFILE_NAME			"logfile"
#define YPC_SUPPORT_CALC_PREEMPTIONTIME	"support_calcpreemptiontime"
#define YPC_SUPPORT_TIMER_TICK		"support_timer_tick"
#define YPC_YASA_SCHEDULER			"yasa_scheduler"					// doc type
#define YPC_SCHEDULER_TYPE			"scheduler_type"					// type of scheduler 0=static
#define YPC_YASA_EXECUTIVE			"yasa_executive"					// doc type
#define YPC_SUPPORT_SOURCE_CODES	"support_source_codes"
#define YPC_SUPPORT_UNLIMITED_CPUS	"support_unlimited_cpus"
#define YPC_SUPPORT_CHANGEABLE_CPUS	"support_changeable_cpus"
#define YPC_SUPPORT_RESUME_TIMES	"support_resume_times"
#define YPC_SUPPORT_RESOURCE_ACTIONS "support_resource_actions"
#define YPC_SUPPORT_EMERGENCY_THREADS "support_emergency_threads"
#define YPC_SUPPORT_CANCEL_THREADS	"support_cancel_threads"
#define YPC_SUPPORT_SCHEDULING_TIME	"support_scheduling_time"
#define YPC_SUPPORT_SYNCHRONIZATION_OFFSET	"support_synchronization_offset"
#define YPC_MAP_IDLE_NAME			"map_idle_name"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																	// ifndef YASAGUI_CONFIG_INCLUDE
