//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Example to demonstrate derived data types
//
// Filename: 	$(YASA)/yasagui/doc/examples/derived_datatypes.cpp
// Author:	  	Jan Blumenthal
// date:		2002/03/28
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "config.h"


TYPEDEF_DERIVE(int, DERIVED_INT)

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int main( int argc, char** argv )
{

	///////////////////////////////////////
	// demonstration of derived objects
	///////////////////////////////////////
	DERIVED_INT		mastervalue(10);
	DERIVED_INT		derivedvalue1(11, &mastervalue);
	DERIVED_INT		derivedvalue2(&derivedvalue1);
	DERIVED_INT		derivedvalue3(12, &derivedvalue2);
	int				value;

	value<<derivedvalue1;										// value will be 11
	qWarning("derivedvalue1: %d", value);
	value<<derivedvalue2;										// value will be 11
	qWarning("derivedvalue2: %d", value);
	qWarning("derivedvalue3: %d", derivedvalue3.GetContent() );	// value will be 12


	/////////////////////////////////////////////////////////////////
	// demonstration of derived objects with disabled feature
	/////////////////////////////////////////////////////////////////
	YTIME		time1(100);
	YTIME		time2(&time1);
	YTIME		time3(&time2);
	YTIME		time4(&time3);
	YTIME		time5(&time4);
	YTIME		time6(&time5);
	YASA_TIME	t;

	time2=200;
	time3=300;
	time4=400;
	time5=500;
	time6=600;

	t=time1;						// t=100
	t=time2;						// t=200
	t=time4;						// t=400
	t=time6;						// t=600

	time4.SetChildsDisabled(true);
	t=time1;						// t=100
	t=time2;						// t=200
	t=time4;						// t=400
	t=time6;						// t=400 !!!

	time4.SetChildsDisabled(false);
	t=time1;						// t=100
	t=time2;						// t=200
	t=time4;						// t=400
	t=time6;						// t=600 !!!

	time1.SetChildsDisabled(true);
	YTIME	time7(&time1);
	time7=700;
	t=time7;						// t=100
	time1.SetChildsDisabled(false);
	t=time7;						// t=700




	return 0;
}
