//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA help window
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/helpwindow.cpp,v 1.3 2003/01/23 09:18:35 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <qdir.h>
#include <qtextcodec.h>
#include "translations.h"
#include "helpwindow.h"
#include "application.h"
#include "settings.h"

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
YFrameHelpArgs::YFrameHelpArgs(const QString &title, const QString &fname) :
YFrameArgs( YHelpFrame::CreateHelpFrame, title),
filename(fname)
{}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YHelpFrame::OpenHelpWindow()
{
	// build name
	QString	title=tr(MSGP_ABOUT_TITLE);
	QString	path;
	if ( QString("") == LANGUAGE_USED )
		path=QDir::currentDirPath() + "/" + ABOUT_PATH + QTextCodec::locale() + HTML_POSTFIX;
	else
		path=QDir::currentDirPath() + "/" + ABOUT_PATH + LANGUAGE_USED + HTML_POSTFIX;
	if ( ! QFile::exists(path) )
		path=QDir::currentDirPath() + "/" + ABOUT_PATH + "en" + HTML_POSTFIX;

	QDir::cleanDirPath( path );

	return YMDIWindow::OpenNewWindow( new YFrameHelpArgs(title, path) );
}



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YHelpFrame::InitInstance()
{
	browser.mimeSourceFactory()->setFilePath( ((YFrameHelpArgs&)GetFrameArgs()).GetFileName() );
	browser.setFrameStyle( QFrame::Panel | QFrame::Sunken );
	browser.setSource( ((YFrameHelpArgs&)GetFrameArgs()).GetFileName() );
	YApplicationFigures::SetTextViewBackdrop( (QTextView&)browser, YApplicationFigures::BACKGROUND_HELPVIEW );
	return YFrame::InitInstance();
}


