//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA project, mutex support
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/mutex.h,v 1.4 2003/01/24 15:47:41 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_MUTEX_INCLUDE
#define	YASAGUI_MUTEX_INCLUDE

#include <yasagui/yasagui.h>
#include <qobject.h>
#include "list.h"
#include "actionhandler.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YTaskSet;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This class contains information about one defined mutex including aggregations to tasks
class YMutex : public YObject
{
	Q_OBJECT
	YASA_MUTEXPROTOCOL		protocol;
	/*YASA_TIME				priorityceiling;
	YASA_TIME				preemptceiling;*/
public:						YMutex(const YObjectArgs &i );
	const YASA_MUTEXPROTOCOL & GetProtocol() const					{ return protocol;			}
	YASA_PRIORITY			GetPriorityCeiling() const;
//	YASA_TIME				GetPriorityCeiling() const;
//	YASA_TIME				GetPreemptCeiling() const				{ return preemptceiling;	}
	void					SetProtocol(int p)						{ protocol=p;				}
	bool					IsUsed() const;

	virtual int				SetConfig(YInputParser &parser);
	virtual int				GetConfig(YOutputParser &parser);
	YTaskSet&				GetTaskSet() const;
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YMutexSet : public YSet
{
public:						YMutexSet();
protected:
	virtual YObject*		AllocNewItem(const YObjectArgs &args)	{ return new YMutex(args);	}
	virtual YActions*		GetItemActions() const
							{ return YActionHandler::GetActions(YActionHandler::MUTEX_ACTIONS);	}
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																	// ifndef YASAGUI_MUTEX_INCLUDE
