//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA result handler declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/03/18
// $Header: /sources/yasa/yasagui/resulthandler.h,v 1.4 2003/01/24 15:47:42 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_RESULT_HANDLER_INCLUDE
#define	YASAGUI_RESULT_HANDLER_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "settings.h"



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! The YResultHandler is an abstract base class which can handle the different versions of showing the
//! results of the simulations
class YResultHandler : public QObject
{	Q_OBJECT
public:
	virtual				~YResultHandler()									{}
	//! Remove all results from handler (e.g. if logfile was changed)
	virtual void		ClearResults() =0;
	//! This function must be called after inserting all timing diagrams
	virtual int			PostCreate()										{	return 0;			}
	//! This function can be used to recreate destroyed widgets (e.g. during ClearResults() )
	virtual int			PostUpdate()										{	return 0;			}
};



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																			// ifndef YASAGUI_RESULT_HANDLER_INCLUDE
