//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA task view window declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/taskviewwindow.h,v 1.1 2003/02/26 14:13:24 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This file contains all information about task windows
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_TASKVIEWWINDOW_INCLUDE
#define	YASAGUI_TASKVIEWWINDOW_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ATTENTION: This code is absolutely BETA and not finished yet !!!
// SegFault during closing Child windows, sometimes
// task.h changed without really thinking...
//	const YASA_PRIORITY	&	GetPriority() const					{ return priority;				}
//	//const YASA_PERIOD &		GetPeriod() const					{ return period;				}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <qtable.h>
#include "mainwindow.h"
#include "widgets.h"
#include "task.h"
#include "project.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YTaskTable : public QTable
{	Q_OBJECT
public:					YTaskTable(QWidget *widget) : QTable(widget)
						{
							connect( this, SIGNAL( valueChanged(int,int) ), this, SLOT(ValueChanged(int,int) ) );
						}
	virtual void		sortColumn ( int col, bool ascending = TRUE, bool wholeRows = FALSE )
						{
							QTable::sortColumn(col, ascending, true);
							clearSelection( true );
							Q_UNUSED(wholeRows);
						}
public slots:
		void			ValueChanged(int row, int col);
};

class YTaskTableItem :  public QObject, public QTableItem
{	Q_OBJECT
	YObject				&object;
public:					YTaskTableItem(QTable &table, YObject &o, const QString &name ) :
						object(o),
						QTableItem(&table, QTableItem::WhenCurrent, name )
						{
							o.connect( &o, SIGNAL( UpdateObject() ), this, SLOT( ObjectChanged() ) );
						}
						~YTaskTableItem()
						{
							int a;
							a=1;
						}
/*	virtual int			alignment()	const
						{
							return AlignVCenter | AlignRight;
						}
*/	QTableItem&			GetItem()
						{
							return *this;
							//return item;
						}
	virtual void		ItemChanged() =0;
protected:	void		SetItemText(const QString &text)
						{
							GetItem().setText(text);
							GetItem().table()->updateCell( GetItem().row(), GetItem().col() );
						}
	YObject&			GetObject()
						{
							return object;
						}
public slots:
	virtual void		ObjectChanged() =0;
};

/*
class YTaskTableItem :  public QTableItem, public QObject
{	Q_OBJECT
	YObject				&object;
	//QTableItem			item;
public:					YTaskTableItem(QTable &table, YObject &o, const QString &name ) :
						object(o),
						item(&table, QTableItem::WhenCurrent, name )
						{
							o.connect( &o, SIGNAL( UpdateObject() ), this, SLOT( ObjectChanged() ) );
						}
						~YTaskTableItem()
						{
							int a;
							a=1;
						}
	virtual int			alignment()	const
						{
							return AlignVCenter | AlignRight;
						}
	QTableItem&			GetItem()
						{
							return *this;
							//return item;
						}
	virtual void		ItemChanged() =0;
protected:	void		SetItemText(const QString &text)
						{
							item.setText(text);
							item.table()->updateCell( item.row(), item.col() );
						}
	YObject&			GetObject()
						{
							return object;
						}
public slots:
	virtual void		ObjectChanged() =0;
};
*/

class YTaskNameTableItem : public YTaskTableItem
{	Q_OBJECT
public:					YTaskNameTableItem(QTable &table, YTask &t ) : YTaskTableItem(table, t, t.GetName() )
						{ }
	virtual void		ObjectChanged()
						{
							SetItemText( GetObject().GetName() );
						}
	virtual void		ItemChanged()
	{
		GetObject().SetName( GetItem().text() );
	}
};
class YTaskPeriodTableItem : public YTaskTableItem
{	Q_OBJECT
public:					YTaskPeriodTableItem(QTable &table, YASA_PERIOD &p ) :
						YTaskTableItem(table, p, p.GetContentString() )
						{}
	virtual void		ObjectChanged()
						{
							SetItemText( ((YASA_PERIOD&)GetObject()).GetContentString() );
						}
	virtual void		ItemChanged()
	{
		((YASA_PERIOD&)GetObject()).ReadFromString(GetItem().text());
	}
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YTaskTableRow
{
	YTaskNameTableItem	taskitem;
	YTaskPeriodTableItem perioditem;
public:					YTaskTableRow(QTable &table, YTask *task, int row ) :
						taskitem(table, *task),
						perioditem(table, task->GetPeriod() )
						{
							table.setItem( row, 0, &(taskitem.GetItem()) );
							table.setItem( row, 1, &(perioditem.GetItem()) );
						}
	static void			SetHeaders( QTable &table )
						{
							QHeader			*header=table.horizontalHeader();
							table.setNumCols(13);
							header->setLabel( 0, MSGP_WIDGET_NAME );
							header->setLabel( 1, MSGP_TASK_PERIOD );
							header->setLabel( 2, MSGP_TASK_REQUIRED_TIME );
							header->setLabel( 3, MSGP_TASK_OFFSET );
							header->setLabel( 4, MSGP_TASK_DEADLINE );
							header->setLabel( 5, MSGP_TASK_DEADLINE_TOLERANCE );
							header->setLabel( 6, MSGP_TASK_DEADLINE_BEHAVIOUR );
							header->setLabel( 7, MSGP_TASK_TYPE );
							header->setLabel( 8, MSGP_TASK_PRIORITY );
							header->setLabel( 9, MSGP_TASK_CPU );
							header->setLabel( 10,MSGP_TASK_INIT_FUNCTION );
							header->setLabel( 11,MSGP_TASK_EXECUTE_FUNCTION );
							header->setLabel( 12,MSGP_TASK_CLEANUP_FUNCTION );
						}
						~YTaskTableRow()
						{
							int a;
							a=1;
						}
public slots:
//	void				Taskdestroyed();
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This frame is showing the task configuration
class YTaskViewFrame : public YObjectFrame
{	Q_OBJECT
	YTaskTable			table;
public:					YTaskViewFrame(QWidget *parent, YFrameArgs &args) :
						YObjectFrame(args),
						table(parent)
						{}
	virtual int			InitInstance();
	virtual QWidget*	GetMainWidget()								{ return &table;	}
	static YFrame*		CreateTaskViewFrame( QWidget *parent, YFrameArgs &args)
						{
							return new YTaskViewFrame(parent, args);
						}
};




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																			// ifndef YASAGUI_TASKVIEWWINDOW_INCLUDE
