//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA work space
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/workspace.h,v 1.4 2003/01/24 15:47:44 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_WORKSPACE_INCLUDE
#define	YASAGUI_WORKSPACE_INCLUDE

#include <yasagui/yasagui.h>
#include <qobject.h>
#include <qdatetime.h>
#include <qfileinfo.h>
#include "project.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YWorkSpace : public YObject
{
	Q_OBJECT
	YApplication			&application;
	QString					filedir;
	QString					filename;
	QString					author;								//! author of workspace
	QDateTime				creation_time;						//! creation date of workspace
	QDateTime				lastchanged_time;					//! last change of workspace
	int						version;							//! version of config
	YProjectSet				projectset;							//! project set
public:						YWorkSpace(YApplication &app);
	void					ResetProjectManager()
							{
								author="";
								projectset.ClearSet();
								creation_time=QDate::currentDate();
								lastchanged_time=QDate::currentDate();
								projectset.SetParent(this);
							}
	int						InitInstance()							{ return 0;					}
	int						RemoveAllProjects();
	int						RemoveProject(YProject *project);

	YApplication&			GetApplication() const					{ return application;		}
	YProjectSet&			GetProjectSet()							{ return projectset;		}
	const QString &			GetAuthor() const						{ return author;			}
	const QDateTime &		GetCreationTime() const					{ return creation_time;		}
	const QDateTime &		GetLastChangedTime() const				{ return lastchanged_time;	}
	const QString &			GetAbsFilePath() const					{ return filedir;			}
	const QString &			GetFileName() const						{ return filename;			}
	void					SetAuthor(const QString &a);
	void					SetCreationTime(const QDateTime &d);
	void					SetLastChangedTime(const QDateTime &d);
	void					SetFilePath(const QString &filepath);


	virtual int				SetConfig(YInputParser &parser);
	virtual int				GetConfig(YOutputParser &parser);
	void					NewObjectCreated(YObject *object)		{ emit NewItem(object);		}
	void					ObjectRemoved(YObject *object)			{ emit ItemRemoved(object);	}

signals:
	void					NewItem(YObject *object);
	void					ItemRemoved(YObject *object);		//! a item
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif															// ifndef YASAGUI_WORKSPACE_INCLUDE
