//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA work space tree view declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/workspacetreeview.h,v 1.4 2003/01/24 15:47:44 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_WORKSPACETREE_VIEW_INCLUDE
#define	YASAGUI_WORKSPACETREE_VIEW_INCLUDE

#include <yasagui/yasagui.h>
#include <qobject.h>
#include <qpopupmenu.h>
#include "widgets.h"
#include "parser.h"
#include "workspace.h"
#include "mainwindow.h"

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YWorkSpaceManager;
class YListViewItem;
class YActionHandler;
class YBackground;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YWorkSpaceTreeView : public YListView
{
	Q_OBJECT
	YObject					*oldselected;
public:
							YWorkSpaceTreeView(YSet *projectset, QFrame *frame) :
							YListView(projectset, frame, QString::null),
							oldselected(0)
							{}
	virtual int				InitInstance();
	YListViewItem*			CreateTreeItem(YObject &object, QListViewItem *parent, QListViewItem *after);
public slots:
	// from QListView
	void					MouseButtonClicked(int, QListViewItem *,const QPoint &,int );
	void					ItemActivated( QListViewItem *item);
//	void					LeftButtonClicked(QListViewItem *,const QPoint &,int );
	void					RightButtonClicked(QListViewItem *,const QPoint &,int );
	void					DoubleClicked(QListViewItem *);
	void					keyPressEvent(QKeyEvent * e);
	void					UpdateListView(YWorkSpace *workspace);
	void					ClearListView(YWorkSpace *workspace);

	virtual void			NewChildObject(YObject *object);			//! A new child object must be inserted
	virtual void			ChildObjectRemoved(YObject *object);		//! The associated item must be removed from list
};







//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YWorkSpaceTreeOutputParser : public YOutputParser, public QList<QListViewItem>
{
	QListViewItem		*afterlistview;
	YWorkSpaceTreeView	&workspaceview;
	YWorkSpace			&workspace;
public:					YWorkSpaceTreeOutputParser(YWorkSpaceTreeView &view, YWorkSpace &ws) :
						afterlistview(0),
						workspaceview(view),
						workspace(ws)
						{}
	virtual int			WriteContentString(const CONFIG_STRING key, const QString &s)
						{	return 0;
							Q_CONSTUNUSED(key);
							Q_CONSTUNUSED(s);
						}
	virtual int			WriteContentInt(const CONFIG_STRING key, int value)
						{
							return 0;
							Q_CONSTUNUSED(key);
							Q_UNUSED(value);
						}
	virtual int			WriteContentObject(const CONFIG_STRING key, const YDerivedObject &object)
						{
							return 0;
							Q_CONSTUNUSED(key);
							Q_CONSTUNUSED(object);
						}
	virtual int			WriteContentState(const CONFIG_STRING key, bool state)
						{
							return 0;
							Q_CONSTUNUSED(key);
							Q_UNUSED(state);
						}
	virtual int			NewSection(const CONFIG_STRING newsectionsetkey, YObject &yobject );
	virtual int			NewSectionSet(const CONFIG_STRING newsectionkey, YSet &yset );
	int					Parse();
};





//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																	// ifndef YASAGUI_WORKSPACETREE_VIEW_INCLUDE
