//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA workspace window code
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/workspacewindow.cpp,v 1.3 2003/01/23 09:18:40 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <qlayout.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include "workspacewindow.h"
#include "translations.h"



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YWorkSpaceFrame::InitInstance()
{
	YWorkSpace			*workspace=(YWorkSpace*) ((YSet*)GetObject())->GetParent();

	QFrame				*mainwidget		= new QFrame( GetMainWidget() );
	QVBoxLayout			*vboxlayout		= new QVBoxLayout(mainwidget, MDI_SCROLLVIEW_BORDER );


	QGroupBox	*group1		= new QGroupBox( 5, Horizontal, MSGP_WIDGET_PROPERTIES	, mainwidget );
	QGroupBox	*group2		= new QGroupBox( 1, Horizontal, MSGP_WIDGET_DESCRIPTION	, mainwidget );

	vboxlayout->addWidget( group1 );
	vboxlayout->addWidget( group2 );
	group1->setAlignment(AlignHCenter);
	group2->setAlignment(AlignHCenter);


	QVBox	*vbox1		= new QVBox(group1);
	QVBox	*vbox2		= new QVBox(group1);


	// splitt vbox2 in 2 vertical boxes
	QVBox	*vbox1_1	= new QVBox( vbox2 );
	QVBox	*vbox1_2	= new QVBox( vbox2 );

	new	QLabel(MSGP_WIDGET_NAME			, vbox1 );
	new QLabel(MSGP_WORKSPACE_AUTHOR	, vbox1 );
	new	QLabel(MSGP_WORKSPACE_STARTDATE	, vbox1 );
	new YNameWidget(	workspace		, vbox1_1 );
	new YAuthorWidget(	workspace		, vbox1_1 );

	// splitt hbox2 in 5 vertical boxes
	QHBox	*hbox2		= new QHBox( vbox1_2 );
	QVBox	*vbox2_1	= new QVBox( hbox2 );
	QFrame	*vbox2_3	= new QFrame(hbox2 );
	QVBox	*vbox2_4	= new QVBox( hbox2 );
	QFrame	*vbox2_5	= new QFrame(hbox2 );
	QVBox	*vbox2_6	= new QVBox( hbox2 );
	vbox2_3->setMinimumWidth(MDI_SCROLLVIEW_BORDER*2);
	vbox2_5->setMinimumWidth(MDI_SCROLLVIEW_BORDER);

	new QLabel(MSGP_WORKSPACE_LASTCHANGED	, vbox2_4 );
	new YCreationTimeWidget(workspace		, vbox2_1 );
	new YLastChangedWidget(	workspace		, vbox2_6 );

	// lower group
	new YDescriptionWidget( workspace, group2 );

	scrollview.addChild(mainwidget);
	scrollview.setResizePolicy(QScrollView::AutoOneFit);

	return YObjectFrame::InitInstance();
}
