//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA workspace window declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/workspacewindow.h,v 1.4 2003/01/24 15:47:44 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This file contains all information about workspace windows
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_WORKSPACEWINDOW_INCLUDE
#define	YASAGUI_WORKSPACEWINDOW_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "mainwindow.h"
#include "widgets.h"
#include "workspace.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This window is showing the workspace configuration
class YWorkSpaceFrame : public YObjectFrame
{	Q_OBJECT
	QScrollView			scrollview;
public:					YWorkSpaceFrame(QWidget *parent, YFrameArgs &args) :
						YObjectFrame(args),
						scrollview(parent)
						{}
	virtual int			InitInstance();
	virtual QWidget*	GetMainWidget()								{ return &scrollview;	}
	static YFrame*		CreateWorkSpaceFrame(QWidget *parent, YFrameArgs &args)
						{
							return new YWorkSpaceFrame(parent, args);
						}
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YAuthorWidget : public YStringWidget
{	Q_OBJECT
public:					YAuthorWidget(YObject *object, QWidget *parent) : YStringWidget(object, parent)	{	UpdateWidget(); }
public slots:
	virtual void		UpdateWidget()							{ if ( text()!=((YWorkSpace*)object)->GetAuthor())
																	setText(((YWorkSpace*)object)->GetAuthor() );		}
	virtual void		UpdateValue( const QString &t)			{ ((YWorkSpace*)object)->SetAuthor( t );				}
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YCreationTimeWidget : public YDateTimeWidget
{	Q_OBJECT
public:					YCreationTimeWidget(YWorkSpace *workspace, QWidget *parent) : YDateTimeWidget(workspace, parent)
						{	UpdateWidget(); }
public slots:
	virtual void		UpdateWidget()							{	if ( GetDateTime()!=((YWorkSpace*)object)->GetCreationTime() )
																	SetDateTime( ((YWorkSpace*)object)->GetCreationTime() ); }
	virtual void		UpdateValue(const QDateTime &date)			{ ((YWorkSpace*)object)->SetCreationTime( date );		}
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YLastChangedWidget : public YDateTimeWidget
{	Q_OBJECT
public:					YLastChangedWidget(YWorkSpace *workspace, QWidget *parent) : YDateTimeWidget(workspace, parent)
						{	UpdateWidget(); }
public slots:
	virtual void		UpdateWidget()							{	if ( GetDateTime() != ((YWorkSpace*)object)->GetLastChangedTime() )
																	SetDateTime( ((YWorkSpace*)object)->GetLastChangedTime() ); }
	virtual	void		UpdateValue(const QDateTime &date)		{ ((YWorkSpace*)object)->SetLastChangedTime( date );			}
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																			// ifndef YASAGUI_WORKSPACEWINDOW_INCLUDE
